! **********************************************************************+
MODULE messy_main_tools_si
! **********************************************************************+

  ! THIS MODULE PROVIDES ROUTINES IN A PSEUDO-PARALLEL ENVIRONMENT
  
  IMPLICIT NONE
  PUBLIC

CONTAINS

  ! --------------------------------------------------------------------
  SUBROUTINE start_message_si(modstr, str, substr)

    USE messy_main_mpi_si,    ONLY: p_parallel_io
    
    IMPLICIT NONE
    INTRINSIC :: TRIM
    
    ! I/O
    CHARACTER(LEN=*), INTENT(IN) :: modstr, str, substr
    
    IF (p_parallel_io) THEN
       WRITE (*,'(75("*"))')
       WRITE(*,*) '*** START ',TRIM(modstr),': ',TRIM(str), &
            ' (',TRIM(substr),')'
    END IF
    
  END SUBROUTINE start_message_si
  ! --------------------------------------------------------------------
  
  ! --------------------------------------------------------------------
  SUBROUTINE end_message_si(modstr, str, substr)
    
    ! ECHAM5
    USE messy_main_mpi_si,    ONLY: p_parallel_io
    
    IMPLICIT NONE
    INTRINSIC :: TRIM

    ! I/O
    CHARACTER(LEN=*), INTENT(IN) :: modstr, str, substr
    
    IF (p_parallel_io) THEN
       WRITE(*,*) '*** END   ',TRIM(modstr),': ',TRIM(str), &
            ' (',TRIM(substr),')'
       WRITE (*,'(75("*"))')
    END IF
    
  END SUBROUTINE end_message_si
  ! --------------------------------------------------------------------

  !---------------------------------------------------------------------
  FUNCTION find_next_free_unit(istart,istop) RESULT(unit)

    USE messy_main_mpi_si, ONLY: finish

    ! I/O
    INTEGER :: istart, istop, unit

    ! LOCAL
    LOGICAL        :: found, opened
    INTEGER        :: i
    CHARACTER(256) :: info

    found = .FALSE.
    DO i=istart,istop
       INQUIRE(unit=i,opened=opened)
       IF (.NOT.opened) THEN
          unit = i
          found = .TRUE.
          EXIT
       END IF
    END DO

    IF (.NOT. found) THEN
       WRITE(info,'(a,i2.2,a,i2.2,a)') &
         'No unit in range <',istart,':',istop,'> free.'
       CALL finish('find_next_free_unit',info)
    END IF

  END FUNCTION find_next_free_unit
!-------------------------------------------------------------------------

! **********************************************************************+
END MODULE messy_main_tools_si
! **********************************************************************+
